//+------------------------------------------------------------------+
//|                                                      ProjectName |
//|                                      Copyright 2020, CompanyName |
//|                                       http://www.companyname.net |
//+------------------------------------------------------------------+
#property copyright "Uniano"
#property link      "http://uniano.com"
#property version   "1.00"
#property strict
#include <Trade\Trade.mqh>
CTrade Trade;
//-----------------------------------------------------------------------------------------------------------------------------------------------
// External variables
input string                        Comment0             = "Leledc-ExhaustionBar1 settings:"; // ................................................
input int                           qual1                = 90;                                 // qual
input int                           len1                 = 60;                                // len
input string                        Comment1              = "Leledc-ExhaustionBar1 settings:"; // ................................................
input int                           qual2                = 90;                                 // qual2
input int                           len2                 = 60;                                // len2
input int                           Distance1            = 1;                                 // Distance
input int                           Countbars1           = 1000;                              // Countbars
input string                        Comment2             = "atrstops_v1 settings:";           // ................................................
input uint                          ATRPeriod            = 7;                                 // Period of ATR
input double                        Kv                   = 3.5;                               // Volatility by ATR
input string                        Comment3             = "Orders settings:";                // ................................................
input double                        Lot                  = 3;                              // Lots size
input ulong                         Magic                = 123;                               // Magic number
input double                        ProfitPercentage     = 1.0;                               // Profit Percentage
input double                        ProfitPercentage2     = 1.0;                               // Profit Percentage sell
input double                        CloseLossPercent     = 1.0;                               // Zarar Yuzdesi (1.0 = 1%)
input double                        CloseLossPercent2     = 1.0;                               // Zarar Yuzdesi sell (1.0 = 1%

//--- input parameters
input group             "MACD"
input int                  Inp_MACD_fast_ema_period= 12;          // MACD: period for Fast average calculation
input int                  Inp_MACD_slow_ema_period= 26;          // MACD: period for Slow average calculation
input int                  Inp_MACD_signal_period  = 9;           // MACD: period for their difference averaging
input ENUM_APPLIED_PRICE   Inp_MACD_applied_price  = PRICE_CLOSE; // MACD: type of price
input double               InpDifference           = 0.00050;     // MACD Difference -> Close All
int      handle_iMACD;                          // variable for storing the handle of the iMACD indicator 
 
  
  
// Local variables
string signal = "",prefix = "Leledc";
int handleleledc1 = 0,handleleledc2 = 0,handleatr = 0,handleMACD = 0;
double buyatr = 0,sellatr = 0, leledcbuy1 = 0,  leledcsell2 = 0,buyMACD=0,sellMACD=0;
datetime indicatorscheck = 0;
double BuyOpenPrice = 0.0;
double SellOpenPrice = 0.0;
double static InitialBalance;
/* Get values */
const double open_price = PositionGetDouble(POSITION_PRICE_OPEN);
const double current_close = iClose(Symbol(), Period(), 1);    // This BTW is the same as the current bid-price!
const double two_percent_of_open_price = open_price / 50.0;
//+------------------------------------------------------------------+
//| Tester function                                                  |
//+------------------------------------------------------------------+
double OnTester()
  {
   double AAA =0,BBB=0;
   if(TesterStatistics(STAT_EQUITY_DD) == 0)
      AAA = Point();
   else
      AAA = TesterStatistics(STAT_EQUITY_DD);
   if(TesterStatistics(STAT_PROFIT_FACTOR) >=200)
      BBB = 200;
   else
      BBB = TesterStatistics(STAT_PROFIT_FACTOR);
   if(TesterStatistics(STAT_TRADES)>=20)
      return((TesterStatistics(STAT_PROFIT)-AAA) /AAA * MathPow(BBB,0.333));
   else
      return(0);
  }



// Initialization
int OnInit()
  {
// Tester check
//if(MQLInfoInteger(MQL_TESTER))prefix="LeledcTest";

// Magic number
   Trade.SetExpertMagicNumber(Magic);

// Filling type
   if(IsFillingTypeAllowed(Symbol(),SYMBOL_FILLING_FOK))
      Trade.SetTypeFilling(ORDER_FILLING_FOK);
   else
      if(IsFillingTypeAllowed(Symbol(),SYMBOL_FILLING_IOC))
         Trade.SetTypeFilling(ORDER_FILLING_IOC);
      else
         Trade.SetTypeFilling(ORDER_FILLING_RETURN);

// Leledc 1 handle
   handleleledc1 = iCustom(Symbol(),PERIOD_CURRENT,"Uniano1",qual1,len1,Distance1,Countbars1);
   if(handleleledc1 < 0)
     {
      Print("Error with leledc 1 handle: ",GetLastError());
      return(-1);
     }
// Leledc 2 handle
   handleleledc2 = iCustom(Symbol(),PERIOD_CURRENT,"Uniano1",qual2,len2,Distance1,Countbars1);
   if(handleleledc2 < 0)
     {
      Print("Error with leledc 2 handle: ",GetLastError());
      return(-1);
     }
 
 // MACD handle
   handle_iMACD=iMACD(Symbol(),Period(),Inp_MACD_fast_ema_period,Inp_MACD_slow_ema_period,
                      Inp_MACD_signal_period,Inp_MACD_applied_price);
      
      //--- if the handle is not created
   if(handle_iMACD==INVALID_HANDLE)
     {
      //--- tell about the failure and output the error code
      PrintFormat("Failed to create handle of the iMACD indicator for the symbol %s/%s, error code %d",
                  Symbol(),
                  EnumToString(Period()),
                  GetLastError());
      //--- the indicator is stopped early
      return(INIT_FAILED);
     }
//---
  

// ATR handle
   handleatr = iCustom(Symbol(),PERIOD_CURRENT,"ATRStopV2", ATRPeriod, Kv);
   if(handleatr < 0)
     {
      Print("Error with atrstops handle: ",GetLastError());
      return(-1);
     }

   return(INIT_SUCCEEDED);
  }
//-----------------------------------------------------------------------------------------------------------------------------------------------
// Data of indicator
double GetIndicatorValue(int handle,int buffer,int shift)
  {
   double buf[];

   if(CopyBuffer(handle, buffer, shift, 1, buf)>0)
      return buf[0];
   else
      Comment(GetLastError());
   return EMPTY_VALUE;
  }
//-----------------------------------------------------------------------------------------------------------------------------------------------
// Filling type
bool IsFillingTypeAllowed(string symbol,int fill_type)
  {
   int filling=(int)SymbolInfoInteger(symbol,SYMBOL_FILLING_MODE);

   return((filling&fill_type)==fill_type);
  }
//----------------------------------------------------------------------------------------------------------------------------------------------- 
 void OnTick()
  {
// Signal
   Signal(); 
    
   double main[],signal[];
   ArraySetAsSeries(main,true);
   ArraySetAsSeries(signal,true);
   int start_pos=0,count=3;
   if(!iGetArray(handle_iMACD,MAIN_LINE,start_pos,count,main) ||
      !iGetArray(handle_iMACD,SIGNAL_LINE,start_pos,count,signal)) 
      
     {
      return;
     } 
    



//-----------------------------------------------------------------------------------------------------------------------------------------------
// Signal
void Signal()
  {
   signal = "";

   if(indicatorscheck!=iTime(Symbol(),PERIOD_CURRENT,0))
     {
      buyatr          = GetIndicatorValue(handleatr,2,1);
      sellatr         = GetIndicatorValue(handleatr,3,1);
      leledcbuy1      = GetIndicatorValue(handleleledc1,0,1);
      leledcsell2     = GetIndicatorValue(handleleledc2,1,1); 
       
       mainsell     = GetIndicatorValue(handle_iMACD,1,1);  
        signalbuy     = GetIndicatorValue(handle_iMACD,0,1); 
       
      indicatorscheck = iTime(Symbol(),PERIOD_CURRENT,0);
     }  
     
//Comment(buyatr,"   ",sellatr);
   if(buyatr!=EMPTY_VALUE && buyatr!=0)
      signal = "buy"; 
       
       
   if(sellatr!=EMPTY_VALUE && sellatr!=0)
      signal = "sell";
  }
//-----------------------------------------------------------------------------------------------------------------------------------------------
// Close orders
void CloseOrders()
  {
   double ASK = SymbolInfoDouble(Symbol(), SYMBOL_ASK);
   double BID = SymbolInfoDouble(Symbol(), SYMBOL_BID);
   double ATRBuy = GetIndicatorValue(handleatr,0,1);
   double ATRSell = GetIndicatorValue(handleatr,1,1); 
   double mainsell     = GetIndicatorValue(handle_iMACD,0,1);
   double signalbuy     = GetIndicatorValue(handle_iMACD,1,1);
   int Bizad = CountOpenedPositions("all");

   if(CountOpenedPositions("buy")!=0 &&
      (signal == "sell" || (leledcsell2 != EMPTY_VALUE && leledcsell2 != 0) ||
       ((BID - ATRBuy)/ATRBuy > ProfitPercentage/1000)))
     {
      CloseAllOrders("buy");
      Comment("Closed By ATR");
     }

   else
      if(CountOpenedPositions("sell")!=0 &&
         (signal == "buy" || (leledcbuy1 != EMPTY_VALUE && leledcbuy1 != 0) ||
          ((ATRSell - ASK)/ATRSell > ProfitPercentage2/1000)))
        {
         CloseAllOrders("sell");
         Comment("Closed By ATR");
        }
 
 else
      if(CountOpenedPositions("sell")!=0 &&
         (signal == "buy" || (leledcbuy1 != EMPTY_VALUE && leledcbuy1 != 0) ||
          (( mainsell -signalbuy   > InpDifference )))
        {
         CloseAllOrders("sell");
         Comment("Closed By MACD");
        }
 
 
      else
         if((CountOpenedPositions("buy") > 0 &&

             ((iClose(Symbol(), Period(), 1))/InitialBalance <= (10000 - CloseLossPercent)/10000)) ||

            (CountOpenedPositions("sell") > 0 &&

             ((iClose(Symbol(), Period(), 1))/InitialBalance   >= (10000 + CloseLossPercent2)/10000)))
           {
            CloseAllOrders("buy");
            CloseAllOrders("sell");
            if(InitialBalance != 0.0)
               Comment("Closed by Initial deposit");
            InitialBalance = 0.0;
           }

//Comment(DoubleToString(InitialBalance * 2.0/ (ASK + BID)),"  ",(100+CloseProfitPercent)/100.0,"  ",(100-CloseLossPercent)/100.0);
  }
//-----------------------------------------------------------------------------------------------------------------------------------------------
// Open orders
void OpenOrders()
  {
   datetime currentopened = (GlobalVariableCheck(prefix+(string)Magic)?(datetime)GlobalVariableGet(prefix+(string)Magic):0);
   datetime currentbar    = iTime(Symbol(),PERIOD_CURRENT,0);
   double ASK = SymbolInfoDouble(Symbol(), SYMBOL_ASK);
   double BID = SymbolInfoDouble(Symbol(), SYMBOL_BID);
   double ATRBuy = GetIndicatorValue(handleatr,0,1);
   double ATRSell = GetIndicatorValue(handleatr,1,1);
 
  double mainsell = GetIndicatorValue(handle_iMACD,0,1);
  double signalbuy = GetIndicatorValue(handle_iMACD,1,1);
   
// Open orders
   if(currentopened!=currentbar)
     {
      // Buy
      if(signal=="buy")
        {
         if(!Trade.Buy(Lot,NULL,0,0,0,DoubleToString(ASK,5)))
           {
            Print("Trade.Buy error #",GetLastError());
            InitialBalance = ASK;
            Comment("");
           }

         else
            GlobalVariableSet(prefix+(string)Magic,(double)currentbar);
        }

      // Sell
      if(signal=="sell")
        {
         if(!Trade.Sell(Lot,NULL,0,0,0,DoubleToString(BID,5)))
           {
            Print("Trade.Sell error #",GetLastError());
            InitialBalance = BID;
            Comment("");
           }

         else
            GlobalVariableSet(prefix+(string)Magic,(double)currentbar);
        }
     }
  }
//-----------------------------------------------------------------------------------------------------------------------------------------------
// Count opened positions
int CountOpenedPositions(string type)
  {
   int count = 0;

   for(int i = PositionsTotal() - 1; i>=0; i--)
     {
      if(PositionSelectByTicket(PositionGetTicket(i)))
        {
         if(PositionGetInteger(POSITION_MAGIC) == Magic)
           {
            if(type=="all")
               count ++;
            if(type=="sell" && PositionGetInteger(POSITION_TYPE)==POSITION_TYPE_SELL)
               count ++;
            if(type=="buy" && PositionGetInteger(POSITION_TYPE)==POSITION_TYPE_BUY)
               count ++;
            if(PositionGetInteger(POSITION_TYPE)==POSITION_TYPE_SELL)
               SellOpenPrice = PositionGetDouble(POSITION_PRICE_OPEN);
            if(PositionGetInteger(POSITION_TYPE)==POSITION_TYPE_BUY)
               BuyOpenPrice = PositionGetDouble(POSITION_PRICE_OPEN);

            InitialBalance = StringToDouble(PositionGetString(POSITION_COMMENT));
           }
        }
     }

   return count;
  }
//-----------------------------------------------------------------------------------------------------------------------------------------------
// Close all orders
void CloseAllOrders(string type)
  {
   for(int s = PositionsTotal() - 1; s>=0; s--)
     {
      if(PositionSelectByTicket(PositionGetTicket(s)))
        {
         if(PositionGetInteger(POSITION_MAGIC) == Magic)
           {
            ulong ticket  = PositionGetTicket(s);
            int typeorder = (int)PositionGetInteger(POSITION_TYPE);

            if(type=="all")
              {
               if(!Trade.PositionClose(ticket))
                  Print("Trade.PositionClose has been ended with error #",GetLastError());
              }
            if(type=="buy" && typeorder==0)
              {
               if(!Trade.PositionClose(ticket))
                  Print("Trade.PositionClose has been ended with error #",GetLastError());
              }
            if(type=="sell" && typeorder==1)
              {
               if(!Trade.PositionClose(ticket))
                  Print("Trade.PositionClose has been ended with error #",GetLastError());
              }
           }
        }
     }
  }
//-----------------------------------------------------------------------------------------------------------------------------------------------
//+------------------------------------------------------------------+
